; 
	include \masm32\include\masm32rt.inc
	.686
	include timers.asm
; 

	; -------------------------------------------------------
	; This is an assembly-time random number generator based
	; on code by George Marsaglia:
	;	#define znew  ((z=36969*(z&65535)+(z>>16))<<16)
	;	#define wnew  ((w=18000*(w&65535)+(w>>16))&65535)
	;	#define MWC   (znew+wnew)
	; -------------------------------------------------------

	@znew_seed@ = 362136069
	@wnew_seed@ = 521228629

	@rnd MACRO base:REQ
		LOCAL znew, wnew
		@znew_seed@ = 36969 * (@znew_seed@ AND 65535) + (@znew_seed@ SHR 16)
		znew = @znew_seed@ SHL 16
		@wnew_seed@ = 18000 * (@wnew_seed@ AND 65535) + (@wnew_seed@ SHR 16)
		wnew = @wnew_seed@ AND 65535
		EXITM <(znew + wnew) MOD base>
	ENDM

; 
	.data
		FOR mem,<m0,m1,m2,m3,m4,m5,m6,m7,m8,m9,ma,mb,mc,md,me,mf>
		mem dd 0
		ENDM
	.code
; 
start:
; 
	mov esi,alloc(1000000*4)

	print "One moment...",13,10,13,10
	invoke Sleep,3500

	counter_begin 1000,HIGH_PRIORITY_CLASS
		REPEAT 1000
			m2m m0,m1
			m2m m2,m3
			m2m m4,m5
			m2m m6,m7
			m2m m8,m9
			m2m ma,mb
			m2m mc,md
			m2m me,mf
		ENDM
	counter_end
	print ustr$(eax)," cycles, m2m sequential direct",13,10

	counter_begin 1000,HIGH_PRIORITY_CLASS
		REPEAT 1000
			mov eax,m1
			mov m0,eax
			mov eax,m3
			mov m2,eax
			mov eax,m5
			mov m4,eax
			mov eax,m7
			mov m6,eax
			mov eax,m9
			mov m8,eax
			mov eax,mb
			mov ma,eax
			mov eax,md
			mov mc,eax
			mov eax,mf
			mov me,eax
		ENDM
	counter_end
	print ustr$(eax)," cycles, mrm sequential direct",13,10,13,10

	counter_begin 1000,HIGH_PRIORITY_CLASS
		REPEAT 1000
			m2m [esi+0],[esi+4]
			m2m [esi+8],[esi+12]
			m2m [esi+16],[esi+20]
			m2m [esi+24],[esi+28]
			m2m [esi+32],[esi+36]
			m2m [esi+40],[esi+44]
			m2m [esi+48],[esi+52]
			m2m [esi+56],[esi+60]
		ENDM
	counter_end
	print ustr$(eax)," cycles, m2m sequential indirect",13,10

	counter_begin 1000,HIGH_PRIORITY_CLASS
		REPEAT 1000
			mov eax,[esi+4]
			mov [esi+0],eax
			mov eax,[esi+12]
			mov [esi+8],eax
			mov eax,[esi+20]
			mov [esi+16],eax
			mov eax,[esi+28]
			mov [esi+24],eax
			mov eax,[esi+36]
			mov [esi+32],eax
			mov eax,[esi+44]
			mov [esi+40],eax
			mov eax,[esi+52]
			mov [esi+48],eax
			mov eax,[esi+60]
			mov [esi+56],eax
		ENDM
	counter_end
	print ustr$(eax)," cycles, mrm sequential indirect",13,10,13,10

	counter_begin 1000,HIGH_PRIORITY_CLASS
		REPEAT 1000
			m2m [esi+@rnd(351)*8],[esi+@rnd(202021)*16]
			m2m [esi+@rnd(5001)*16],[esi+@rnd(101021)*8]
			m2m [esi+@rnd(10003)*8],[esi+@rnd(56569)*16]
			m2m [esi+@rnd(33004)*16],[esi+@rnd(19231)*8]
			m2m [esi+@rnd(50108)*8],[esi+@rnd(13121)*16]
			m2m [esi+@rnd(90010)*16],[esi+@rnd(1871)*8]
			m2m [esi+@rnd(140020)*8],[esi+@rnd(431)*16]
			m2m [esi+@rnd(241040)*16],[esi+@rnd(313)*8]
		ENDM
	counter_end
	print ustr$(eax)," cycles, m2m random indirect",13,10

	counter_begin 1000,HIGH_PRIORITY_CLASS
		REPEAT 1000
			mov eax,[esi+@rnd(202021)*16]
			mov [esi+@rnd(351)*8],eax
			mov eax,[esi+@rnd(101021)*16]
			mov [esi+@rnd(5001)*8],eax
			mov eax,[esi+@rnd(56569)*16]
			mov [esi+@rnd(10003)*8],eax
			mov eax,[esi+@rnd(19231)*16]
			mov [esi+@rnd(33004)*8],eax
			mov eax,[esi+@rnd(13121)*16]
			mov [esi+@rnd(50108)*8],eax
			mov eax,[esi+@rnd(1871)*16]
			mov [esi+@rnd(90010)*8],eax
			mov eax,[esi+@rnd(431)*16]
			mov [esi+@rnd(140020)*8],eax
			mov eax,[esi+@rnd(313)*16]
			mov [esi+@rnd(241040)*8],eax
		ENDM
	counter_end
	print ustr$(eax)," cycles, mrm random indirect",13,10,13,10

	inkey "Press any key to exit..."
	exit
; 
end start
